// to download S&P 500 data use https://www.marketwatch.com/investing/index/spx/download-data
#include "HMG.CH"
#include "fileio.ch"
FUNCTION main()

SET DATE BRIT
SET CENTURY ON

DEFINE WINDOW SP500Dnld MAIN AT 0,0 WIDTH 200 HEIGHT 200

       DEFINE LABEL Lbl_From
         ROW 20                                                    
         COL 20
         WIDTH 50
         HEIGHT 20
         VALUE "From :"
       END LABEL

       DEFINE DATEPICKER datepicker_1
	   ROW 20
	   COL 80
	   WIDTH 100
	   HEIGHT 20
	   ONLOSTFOCUS getDay("F")
	   VALUE Date() - 1
       END DATEPICKER
	   
	   DEFINE LABEL Lbl_1
         ROW 40
         COL 20
         WIDTH 150
         HEIGHT 20
	     VALUE ""
      END LABEL
	   
	   DEFINE LABEL Lbl_To
         ROW 60                                                    
         COL 20
         WIDTH 50
         HEIGHT 20
         VALUE "To :"
       END LABEL

       DEFINE DATEPICKER datepicker_2
	   ROW 60
	   COL 80
	   WIDTH 100
	   HEIGHT 20
	   ONLOSTFOCUS getDay("T")
	   VALUE Date() - 1
       END DATEPICKER
	  
      DEFINE LABEL Lbl_2
         ROW 80
         COL 20
         WIDTH 150
         HEIGHT 20
         VALUE ""
      END LABEL	  

      DEFINE PROGRESSBAR Progress_Symbols
         ROW 100                                                     
         COL 2                                                      
         RANGEMIN 0
         RANGEMAX 501                                                
         VALUE 0
         WIDTH 185                                                   
         HEIGHT 20         
      END PROGRESSBAR

       DEFINE BUTTON Button_1
          ROW 130
          COL 20
          WIDTH 100
          HEIGHT 30
          CAPTION "Download" 
          ACTION Download()
      END BUTTON	

      

      		 
	  
	  
END WINDOW
SP500Dnld.center
SP500Dnld.activate
RETURN nil	  

****************************************************************


/*  url syntax
https://www.marketwatch.com/investing/index/spx/downloaddatapartial?startdate=08/26/2024%2000:00:00&enddate=08/27/2024%2000:00:00&daterange=d30&frequency=p1d&csvdownload=true&downloadpartial=true&newdates=false 
*/


FUNCTION Download()
LOCAL cUrl, cFileZIP, dDate, dDate1, dDate2, cHost, lGotfile := .f.

      dDate1 := SP500Dnld.datepicker_1.value
      dDate := dDate1
	   
	  dDate2 := SP500Dnld.datepicker_2.value
	  
	  aSP500Symbols := SP500List ()
	  
	  Do while !lGotFile .and. dDate <= SP500Dnld.datepicker_2.value 
	  
	     cFile := dtos (dDate) + "SP500.csv"
         
         IF ( nh := FCREATE( cFile ) ) == F_ERROR
            msgstop( "Cannot create file " + cFile + " Exiting..." )
            RETURN
         ENDIF

		 FWRITE ( nH, "Ticker,Date,Open,High,Low,Close,Volume" + CRLF )

	     cDate := dtoc ( dDate )
         cDate := substr (cDate , 4 , 2 ) + "/" + substr (cDate , 1 , 2 ) + "/" + substr (cDate , 7 ) // "MM/DD/YYYY 		 
	  
         cStart := TIME()
         cString := ''
         nTotTime1 := 0
         ntime1 := 0
         SP500Dnld.progress_Symbols.RangeMax := len (aSP500Symbols) + 1
         lExit := .f.
         FOR i = 1 TO LEN( aSP500Symbols )                            //131 to 155 //1 to len (aSP500Symbols)

            
            // for shares
            cUrl :=  "https://www.marketwatch.com/investing/stock/"+aSP500Symbols[ i ]+"/downloaddatapartial?startdate="+cDate+"%2000:00:00&enddate="+cDate+"%2000:00:00&daterange=d30&frequency=p1d&csvdownload=true&downloadpartial=false&newdates=false"
            // Allows maximum of 1 year of data to downloaded at a time and also quotes are enclosed in double quotation marks which needs
            // to be removed before AMibroker can import them
		
			cfileSymbol := aSP500Symbols[ i ] + ".csv"

            cLineRecd := Downloadfile( cUrl, cFileSymbol )
			
			
			DO EVENTS
			
			 
            IF EMPTY( cLineRecd )
               //lExit := .t.
               EXIT
            ENDIF
			cLineRecd := substr (cLineRecd, at ('"',cLineRecd) )
			
			atokens := hb_aTokens (cLineRecd, ',')
			cOpen := strtran ( aTokens [ 1 ] ,'"' , "")
			cHigh := strtran ( aTokens [ 2 ] ,'"' , "")
			cLow  := strtran ( aTokens [ 3 ] ,'"' , "")
			cClose := strtran ( aTokens [ 4 ] ,'"' , "")
			for y = 1 to 9
			    
			    cLineRecd := substr ( cLineRecd, at ('"',cLineRecd) + 1 ) 
			
			next
			
			cVol := strtran ( cLineRecd, '"',"") //substr (cLineRecd, nVolStart + 1 )
			cVol := strtran ( cVol ,',',"") 
			cQuote := aSP500Symbols[ i ] + ","+ dtoc (dDate) + "," + copen + "," + cHigh + "," + cLow + "," + cClose + "," + cVol 

            if ! empty (cQuote)			
               cString += cQuote
			endif    
            SP500Dnld.progress_Symbols.value :=  i /// LEN( aSP500Symbols ) //* 100	
			SP500Dnld.progress_Symbols.Refresh()
         NEXT
		 IF !lExit
			cUrl :=  "https://www.marketwatch.com/investing/index/spx/downloaddatapartial?startdate="+cDate+"%2000:00:00&enddate="+cDate+"%2000:00:00&daterange=d30&frequency=p1d&csvdownload=true&downloadpartial=false&newdates=false"

            cFileIdx := "SP500Index.csv"

            cLineRecd := Downloadfile( cUrl, cFileIdx )
			DO EVENTS
			
			
			atokens := hb_aTokens (cLineRecd, ',')
			cOpen := strtran ( aTokens [ 1 ] ,'"' , "")
			cHigh := strtran ( aTokens [ 2 ] ,'"' , "")
			cLow  := strtran ( aTokens [ 3 ] ,'"' , "")
			cClose := strtran ( aTokens [ 4 ] ,'"' , "")
			for y = 1 to 9
			
			    cLineRecd := substr ( cLineRecd, at ('"',cLineRecd) + 1 ) 
			
			next
			
			cLineRecd := substr (cLineRecd, at ('"',cLineRecd) )
			cQuote := "SPX" +","+ dtoc (dDate) + "," + cOpen + "," + cHigh + "," + cLow + "," + cClose 
            cString += cQuote
            FWRITE ( nH, cString )
            FCLOSE ( nH )                                              
         ELSE
            FCLOSE ( nH )
            FERASE ( cFile )                                           
         ENDIF

         dDate ++
         msgdebug (cString) 
      ENDDO //!lGotFile .AND. dDate <= SP500.datepicker_2.value

	  
   msginfo ( "Done"+CRLF+"Time taken "+elaptime (cStart,time()) )
RETURN	  
	  

****************************************************************
FUNCTION GetDay( cMode )
if cMode == "F"
SP500Dnld.Lbl_1.value := cdow(SP500Dnld.datepicker_1.value)
else
SP500Dnld.Lbl_2.value := cdow(SP500Dnld.datepicker_2.value)
endif
RETURN nil

****************************************************************




FUNCTION downloadfile( cURL, cfile )

LOCAL lOk, nFileSize, nKb, nMb, nGBcUnit, cLine, recv
recv := ""
   BEGIN SEQUENCE WITH { | e | BREAK( e ) }
   oSoap := Win_OleCreateObject( "Msxml2.XMLHTTP.6.0" )
   RECOVER
      MsgStop( "Microsoft XML Core Services (MSXML) 6.0 is not installed." + CRLF + ;
               "Download and install MSXML 6.0 from http://msdn.microsoft.com/xml" + CRLF + ;
               "before continuing." )
      RETURN

   END SEQUENCE

   BEGIN SEQUENCE WITH { | o | BREAK( o ) }
      
      oSoap:Open( "GET", cUrl, .F. )
      oSoap:setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" )
      oSoap:setRequestHeader( "Accept", "*/*" )                       
      oSoap:setRequestHeader( "X-Requested-With", "XMLHttpRequest" )
      oSoap:setRequestHeader( "User-Agent", "Mozilla/5.0 (Linux; Android 5.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Mobile Safari/537.36" )
      oSoap:setRequestHeader( "DNT", "1" )
      oSoap:setRequestHeader( "Referer", "https://www.marketwatch.com/investing/" )

      oSoap:Send()
      recv := oSoap:responseBody()
   RECOVER USING oError

      MsgStop( IF( VALTYPE( oError ) = 'O', oError:Description, oError ) )

   END SEQUENCE
   IF ! empty (recv) .and. "404 Not Found:" $ recv
      cLine := ""
   ELSE
      cLine := recv
   ENDIF

   oSoap:Abort()
   oSoap := Nil
   DO EVENTS
RETURN cLine

FUNCTION SP500List()

LOCAL aSymbols
   aSymbols := {}
   // follo is copied from D:\HMG-SAMPLES\hmgforum\USMarkets\SP500\Temp.csv file
   aSymbols := { "A", "AAL", "AAP", "AAPL", "ABBV", "ABT", "ACGL", "ACN", "ADBE", "ADI", "ADM", "ADP", "ADSK", "AEE", "AEP", "AES", "AFL", "AIG", "AIZ", "AJG", "AKAM", "ALB", "ALGN", "ALK", "ALL", "ALLE", "AMAT", "AMCR", "AMD", "AME", "AMGN", "AMP", "AMT", "AMZN", "ANET", "ANSS", "AON", "AOS", "APA", "APD", "APH", "APTV", "ARE", "ATO", "AVB", "AVGO", "AVY", "AWK", "AXON", "AXP", "AZO", "BA", "BAC", "BALL", "BAX", "BBWI", "BBY", "BDX", "BEN", "BF.B", "BG", "BIIB", "BIO", "BK", "BKNG", "BKR", "BLK", "BMY", "BR", "BRK.B", "BRO", "BSX", "BWA", "BXP", "C", "CAG", "CAH", "CARR", "CAT", "CB", "CBOE", "CBRE", "CCI", "CCL", "CDNS", "CDW", "CE", "CEG", "CF", "CFG", "CHD", "CHRW", "CHTR", "CI", "CINF", "CL", "CLX", "CMA", "CMCSA", "CME", "CMG", "CMI", "CMS", "CNC", "CNP", "COF", "COO", "COP", "COST", "CPB", "CPRT", "CPT", "CRL", "CRM", "CSCO", "CSGP", "CSX", "CTAS", "CTRA", "CTSH", "CTVA", "CVS", "CVX", "CZR", "D", "D", "DAL", "DD", "DE", "DFS", "DG", "DGX", "DHI", "DHR", "DIS", "DLR", "DLTR", "DOC", "DOV", "DOW", "DPZ", "DRI", "DTE", "DUK", "DVA", "DVN", "DXC", "DXCM", "EA", "EBAY", "ECL", "ED", "EFX", "EG", "EIX", "EL", "ELV", "EMN", "EMR", "ENPH", "EOG", "EPAM", "EQIX", "EQR", "EQT", "ES", "ESS", "ETN", "ETR", "ETSY", "EVRG", "EW", "EXC", "EXPD", "EXPE", "EXR", "F", "FANG", "FAST", "FCX", "FDS", "FDX", "FE", "FFIV", "FI", "FICO", "FIS", "FITB", "FMC", "FOX", "FOXA", "FRT", "FSLR", "FTNT", "FTV", "GD", "GE", "GEHC", "GEN", "GILD", "GIS", "GL", "GLW", "GM", "GNRC", "GOOG", "GOOGL", "GPC", "GPN", "GRMN", "GS", "GWW", "HAL", "HAS", "HBAN", "HCA", "HD", "HES", "HIG", "HII", "HLT", "HOLX", "HON", "HPE", "HPQ", "HRL", "HSIC", "HST", "HSY", "HUM", "HWM", "IBM", "ICE", "IDXX", "IEX", "IFF", "ILMN", "INCY", "INTC", "INTU", "INVH", "IP", "IPG", "IQV", "IR", "IRM", "ISRG", "IT", "ITW", "IVZ", "J", "JBHT", "JCI", "JKHY", "JNJ", "JNPR", "JPM", "K", "KDP", "KEY", "KEYS", "KHC", "KIM", "KLAC", "KMB", "KMI", "KMX", "KO", "KR", "L", "LDOS", "LEN", "LH", "LHX", "LIN", "LKQ", "LLY", "LMT", "LNC", "LNT", "LOW", "LRCX", "LUV", "LVS", "LW", "LYB", "LYV", "MA", "MAA", "MAR", "MAS", "MCD", "MCHP", "MCK", "MCO", "MDLZ", "MDT", "MET", "META", "MGM", "MHK", "MKC", "MKTX", "MLM", "MMC", "MMM", "MNST", "MO", "MOH", "MOS", "MPC", "MPWR", "MRK", "MRNA",  "MS", "MSCI", "MSFT", "MSI", "MTB", "MTCH", "MTD", "MU", "NCLH", "NDAQ", "NDSN", "NEE", "NEM", "NFLX", "NI", "NKE", "NOC", "NOW", "NRG", "NSC", "NTAP", "NTRS", "NUE", "NVDA", "NVR", "NWL", "NWS", "NWSA", "NXPI", "O", "ODFL", "OGN", "OKE", "OMC", "ON", "ORCL", "ORLY", "OTIS", "OXY", "PANW", "PARA", "PAYC", "PAYX", "PCAR", "PCG", "PEG", "PEP", "PFE", "PFG", "PG", "PGR", "PH", "PHM", "PKG", "PLD", "PM", "PNC", "PNR", "PNW", "PODD", "POOL", "PPG", "PPL", "PRU", "PSA", "PSX", "PTC", "PWR", "PYPL", "QCOM", "QRVO", "RCL", "REG", "REGN", "RF", "RHI", "RJF", "RL", "RMD", "ROK", "ROL", "ROP", "ROST", "RSG", "RTX", "RVTY", "SBAC", "SBUX", "SCHW", "SEDG", "SEE", "SHW", "SJM", "SLB", "SNA", "SNPS", "SO", "SPG", "SPGI", "SRE", "STE", "STLD", "STT", "STX", "STZ", "SWK", "SWKS", "SYF", "SYK", "SYY", "T", "TAP", "TDG", "TDY", "TECH", "TEL", "TER", "TFC", "TFX", "TGT", "TJX", "TMO", "TMUS", "TPR", "TRGP", "TRMB", "TROW", "TRV", "TSCO", "TSLA", "TSN", "TT", "TTWO", "TXN", "TXT", "TYL", "UAL", "UDR", "UHS", "ULTA", "UNH", "UNP", "UPS", "URI", "USB", "V", "VFC", "VICI", "VLO", "VMC", "VRSK", "VRSN", "VRTX", "VTR", "VTRS", "VZ", "WAB", "WAT", "WBA", "WBD", "WDC", "WEC", "WELL", "WFC", "WHR", "WM", "WMB", "WMT", "WRB", "WST", "WTW", "WY", "WYNN", "XEL", "XOM", "XRAY", "XYL", "YUM", "ZBH", "ZBRA", "ZION", "ZTS" }
RETURN aSymbols
